SystemOrganization addCategory: #ProxiesTests!

!AbstractMareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:29'!
internalMethodForTesting
	^ self shouldBeImplemented ! !

!CompiledMethodProxySwapperHandler classSide methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 4/1/2011 16:08'!
forTestingUninstallForProxy: aProxy compiledMethod: aMethod
	| oldMethod |
	aProxy mareaIsProxyInstalled ifFalse: [^ nil].
	oldMethod := aMethod.
	self mareaLog: 'The CompiledMethod ', oldMethod mareaPrintString, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self mareaLog: 'The Proxy for ', oldMethod mareaPrintString, ' was uninstalled.'.
	self removeFile: aProxy mareaFileName.
	aProxy mareaMarkAsUninstalled.
	^ oldMethod.  
! !

!ProtoObject methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/30/2010 15:43'!
size
	^ -1! !

TestCase subclass: #AbstractCompiledMethodProxyTest
	instanceVariableNames: 'proxyClass proxyInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
crashTestCompiledMethodProxy2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: PseudoContext  selector: #isPseudoContext.
	[self assert: (PseudoContext methodDict at: #isPseudoContext) class name equals:  self proxyClassName.
	aProxy zaraza.
	self assert: (PseudoContext methodDict at: #isPseudoContext) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'helper' stamp: ''!
installCompiledMethodProxyOn: aClass selector: aSelector
	^ self proxyClass installOn: aClass selector: aSelector.! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: ''!
proxyClass
	^ proxyClass
	

! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: ''!
proxyClassInstance
	^ proxyInstance
	

! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: ''!
proxyClassName
	^ self proxyClass name! !

!AbstractCompiledMethodProxyTest methodsFor: 'running' stamp: ''!
setUp
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	FilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := FilenameCompiledMethodProxySwapper.
	proxyInstance := FilenameCompiledMethodProxySwapper new.
	
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'running' stamp: ''!
tearDown
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodMessageSent
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: (ClassWith1Var methodDict at: #foo) literals size equals: 3.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodMessageSentByPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict at: #foo) perform: #literals) size equals: 3.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodMessageSentByPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[self assert: (ClassWith1Var methodDict at: #foo:) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self assert: ((ClassWith1Var methodDict at: #foo:) perform: #literals) size equals: 3.
	self assert: (ClassWith1Var methodDict at: #foo:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodMessageSentByPerformWithNotUnderstood
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also."
	self should: [(ClassWith1Var methodDict at: #foo) perform: #nonExistentMethod] raise: Error.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodMessageSentByPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals:  self proxyClassName.
	"Notice that in this case we are not executing the CompiledMethod but instead, sending messages to it.
	In this case, the original method should be back also." 
	self should: [(ClassWith1Var methodDict at: #foo) perform: #fooDNU] raise: Error.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxy
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals:  self proxyClassName.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyAllInstalledProxiesCount
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 aProxy3 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
	[self assert: self proxyClass mareaAllInstalledProxiesCount equals: 3.
	"This will automatically uninstall the proxy"
	ClassWith1Var new foo.
	self assert: self proxyClass mareaAllInstalledProxiesCount equals: 2.
	aProxy2 mareaUninstallIfNeeded. 
	self assert: self proxyClass mareaAllInstalledProxiesCount equals: 1.
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyAndGC
	"A simple CompiledMethodProxy test"
	| aProxy methodsInstCountFirst  methodsInstCountEnd proxyCount proxyCountEnd|
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountFirst := CompiledMethod instanceCount.
	proxyCount := self proxyClass instanceCount.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals:  self proxyClassName.
	"This line is important because the MCMethodDefinition have references to the CompiledMethod"
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountEnd := CompiledMethod instanceCount.
	proxyCountEnd := self proxyClass instanceCount.
	self assert: (methodsInstCountFirst - 1) equals: methodsInstCountEnd.
	(self proxyClass = SmallInteger) ifFalse: [self assert: (proxyCount + 1) equals: proxyCountEnd].
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	aProxy := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	methodsInstCountEnd := CompiledMethod instanceCount.
	proxyCountEnd := self proxyClass instanceCount.
	self assert: methodsInstCountFirst equals: methodsInstCountEnd.
	self assert: proxyCount equals: proxyCountEnd.
	] ensure: [
		aProxy isNil ifFalse: [aProxy mareaUninstallIfNeeded].
		MCMethodDefinition shutDown. 
		Smalltalk garbageCollect].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyAndPerform
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: ((ClassWith1Var methodDict at: #foo) class name = self proxyClassName).
	self assert: ((ClassWith1Var new perform: #foo) = 'foo').
	self assert: ((ClassWith1Var methodDict at: #foo) class name = #CompiledMethod).
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyAndPerformWith
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo:.
	[self assert: (ClassWith1Var methodDict at: #foo:) class name equals:  self proxyClassName.
	self assert: (ClassWith1Var new perform: #foo: with: 2) equals: 'foo'.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyAndPerformWithNotUnderstood2
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooDNU.
	[self assert: (ClassWith1Var methodDict at: #fooDNU) class name equals:  self proxyClassName.
	self should: [ClassWith1Var new perform: #fooDNU ] raise: Error. 
	self assert: (ClassWith1Var methodDict at: #fooDNU) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyCaseSensitive
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #fOO.
	
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals: self proxyClassName.
	self assert: (ClassWith1Var methodDict at: #fOO) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var methodDict at: #fOO) class name equals: self proxyClassName.
	self assert: (ClassWith1Var new fOO = 'fOO').
	self assert: (ClassWith1Var methodDict at: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var methodDict at: #fOO) class name equals: #CompiledMethod.
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyCategory
	"A simple CompiledMethodProxy test"
	| aProxy |
	self assert: (ClassWith1Var >> #foo) category = #accessing.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var >> #foo) category equals:  #accessing.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyCategory2
	"A simple CompiledMethodProxy test"
	| aProxy |
	self assert: (ClassWith1Var >> #fooCategory) category equals: #'test - category'.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new fooCategory equals: 'fooCategory'.
	self assert: (ClassWith1Var methodDict at: #fooCategory) class name equals: #CompiledMethod.
	self assert: (ClassWith1Var >> #fooCategory) category equals: #'test - category'.
	self assert: (ClassWith1Var organization listAtCategoryNamed: #'test - category') size equals: 1.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyClassMethod
	"A simple CompiledMethodProxy test"
	| aProxy  aProxyClass|
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxyClass := self proxyClass.
	aProxyClass runningTest: false.
	[self assert: (ClassWith1Var methodDict at: #foo) mareaClass equals: aProxyClass.
	self assert: (ClassWith1Var methodDict at: #foo) class equals: CompiledMethod.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyClassMethodNotTesting
	"A simple CompiledMethodProxy test"
	| aProxy |
	self proxyClass runningTest: false.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	self assert: (ClassWith1Var new foo = 'foo').
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyDNUMessage
	self should: [self proxyClassInstance perform: #zaraza] raise: MessageNotUnderstood.! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyDifficult
	"A simple CompiledMethodProxy test"
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: TestRunner selector: #addMethodsUnderTestIn:to:.
	[self assert: (TestRunner methodDict at: #addMethodsUnderTestIn:to:) class name equals: self proxyClassName.
	TestRunner new addMethodsUnderTestIn: (Array with: (PackageInfo named: 'VMMaker')) to: (OrderedCollection with: CompiledMethod toReturnSelf).
	self assert: (TestRunner methodDict at: #addMethodsUnderTestIn:to:) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyFlushCache
	"A simple CompiledMethodProxy test"
	| aProxy anObject |
	anObject := ClassWith1Var new. 
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #fooSomething.
	[self assert: (ClassWith1Var methodDict at: #fooSomething) class name equals: self proxyClassName.
	self assert: anObject fooSomething equals: 'fooSomething'.
	self assert: anObject fooSomething equals: 'fooSomething'.
	self assert: (ClassWith1Var methodDict at: #fooSomething) class name equals: #CompiledMethod.
	self assert: anObject fooSomething equals: 'fooSomething'.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyIdentifyProblem
	"A simple CompiledMethodProxy test"
	| aProxy method |
	method := ClassWith1Var >>#foo.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[ self deny: aProxy == method. 
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyInstallTwice
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	self shouldnt: [aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo] raise: Error.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals: self proxyClassName.
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals: #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].


! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyInstallingInSuperclassMethodDict
	
	self should: [self installCompiledMethodProxyOn: ClassWith1Var selector: #name] raise: SelectorNotFoundError.! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxySwapDNUMessage
	"A simple CompiledMethodProxy test"
	
	| aProxy |
	
	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	
	[self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self assert: (ClassWithDNU new doesNotUnderstand: 'zaraza') equals: 'dnu'.
	self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self assert: (ClassWithDNU new zaraza) equals: 'dnu'.
	self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict at: #doesNotUnderstand:) zaraza] raise: MessageNotUnderstood.
	self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict at: #doesNotUnderstand:) zaraza] raise: MessageNotUnderstood.
	self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].

	aProxy := self installCompiledMethodProxyOn: ClassWithDNU selector: #doesNotUnderstand:.
	[self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  self proxyClassName.
	self should: [(ClassWithDNU methodDict at: #doesNotUnderstand:) doesNotUnderstand: 'aa'] raise: MessageNotUnderstood.
	"The proxy is uninstalled in this case since it doesn't understand #doesNotUnderstand:"
	self assert: (ClassWithDNU methodDict at: #doesNotUnderstand:) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyUnInstall
	"A simple CompiledMethodProxy test"
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	"This will automatically uninstall the proxy"
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].


	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	aProxy mareaUninstall.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyUnInstallAllInstances
	"A simple CompiledMethodProxy test"
	| aProxy aProxy2 aProxy3 |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	aProxy2 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo2.
	aProxy3 := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo3.
	[self assert: aProxy mareaIsProxyInstalled.
	self assert: aProxy2 mareaIsProxyInstalled.
	self assert: aProxy3 mareaIsProxyInstalled.	
	
	"This will automatically uninstall the proxy"
	self assert: ClassWith1Var new foo equals: 'foo'.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	self assert: aProxy2 mareaIsProxyInstalled.
	self assert: aProxy3 mareaIsProxyInstalled.	
	
	self proxyClass mareaUninstallIfNeededAllInstances.
	
	self assert: (ClassWith1Var methodDict at: #foo2) class name equals: #CompiledMethod.
	self deny: aProxy2 mareaIsProxyInstalled.
	self assert: (ClassWith1Var methodDict at: #foo3) class name equals: #CompiledMethod.
	self deny: aProxy3 mareaIsProxyInstalled.
	
	] ensure: [ 
		aProxy mareaUninstallIfNeeded.
		aProxy2 mareaUninstallIfNeeded.
		aProxy3 mareaUninstallIfNeeded.].
! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testCompiledMethodProxyUnInstallMultipleTimes
	| aProxy |
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals: self proxyClassName.
	self assert: aProxy mareaIsProxyInstalled.
	aProxy mareaUninstall.
	self should: [aProxy mareaUninstall.] raise: ProxyIsNotInstalled.
	self assert: (ClassWith1Var methodDict at: #foo) class name equals: #CompiledMethod.
	self deny: aProxy mareaIsProxyInstalled.
	] ensure: [ aProxy mareaUninstallIfNeeded].! !

!AbstractCompiledMethodProxyTest methodsFor: 'accessing' stamp: ''!
testSelector 
	^ testSelector ! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
testSerializeCompiledMethod
	| method newMethod serializer |
method := ClassWith1Var >> #foo.
	"method := FormCanvas>> #transformBy:clippingTo:during:smoothing:.
	"
	"
method := (Refactoring class>>#initializeRefactoringOptions ).

method := RefactoryChangeManager class >> #settingsOn:.
"
	serializer := CompiledMethodProxySwapperHandler serializer. 
	
	"
	serializer := FuelMareaSerializer new.
	"
	
	serializer serializeAndWriteObject: method to: 'zaraza'.
	
	newMethod := serializer unserializeObjectFrom:  'zaraza'.

	self assert: method = newMethod.
	! !

!AbstractCompiledMethodProxyTest methodsFor: 'tests' stamp: ''!
xtestCompiledMethodProxyWhenBothUnderstandSameMessage
	| aProxy methodSize |
	methodSize := (ClassWith1Var >> #foo) size.
	aProxy := self installCompiledMethodProxyOn: ClassWith1Var selector: #foo.
	[self assert: (ClassWith1Var methodDict at: #foo) class name equals:  self proxyClassName.
	self deny: (ClassWith1Var methodDict at: #foo) size = aProxy size. 
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	self assert: (ClassWith1Var methodDict at: #foo) size = methodSize. 
	self assert: (ClassWith1Var methodDict at: #foo) class name equals:  #CompiledMethod.
	] ensure: [ aProxy mareaUninstallIfNeeded].
! !

AbstractCompiledMethodProxyTest subclass: #FilenameCompiledMethodProxySwapperFuelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!FilenameCompiledMethodProxySwapperFuelTest methodsFor: 'accessing' stamp: ''!
setUp
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	FilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := FilenameCompiledMethodProxySwapper.
	proxyInstance := FilenameCompiledMethodProxySwapper new! !

AbstractCompiledMethodProxyTest subclass: #FilenameCompiledMethodProxySwapperReferenceStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!FilenameCompiledMethodProxySwapperReferenceStreamTest methodsFor: 'accessing' stamp: ''!
setUp
	CompiledMethodProxySwapperHandler serializer: ReferenceStreamMareaSerializer. 
	FilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := FilenameCompiledMethodProxySwapper.
	proxyInstance := FilenameCompiledMethodProxySwapper new! !

AbstractCompiledMethodProxyTest subclass: #NumberAsFilenameCompiledMethodProxySwapperFuelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!NumberAsFilenameCompiledMethodProxySwapperFuelTest methodsFor: 'accessing' stamp: ''!
setUp
	CompiledMethodProxySwapperHandler serializer: FuelMareaSerializer. 
	NumberAsFilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := NumberAsFilenameCompiledMethodProxySwapper.
	proxyInstance := NumberAsFilenameCompiledMethodProxySwapper new


! !

AbstractCompiledMethodProxyTest subclass: #NumberAsFilenameCompiledMethodProxySwapperReferenceStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!NumberAsFilenameCompiledMethodProxySwapperReferenceStreamTest methodsFor: 'accessing' stamp: ''!
setUp
	CompiledMethodProxySwapperHandler serializer: ReferenceStreamMareaSerializer. 
	NumberAsFilenameCompiledMethodProxySwapper runningTest: true.
	proxyClass := NumberAsFilenameCompiledMethodProxySwapper.
	proxyInstance := NumberAsFilenameCompiledMethodProxySwapper new


! !

TestCase subclass: #ClassProxySwapperTest
	instanceVariableNames: 'proxyClassName proxyClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: ''!
installClassProxyOn: aClass
	^ self proxyClass installOn: aClass
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: ''!
proxyClass
	^ proxyClass ! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 7/1/2011 15:42'!
setUp
	ClassProxySwapperHandler serializer: FuelMareaSerializer. 
	proxyClass := ClassProxySwapper.
	proxyClassName := self proxyClass name.  
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	self proxyClass runningTest: true.
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 7/4/2011 12:22'!
testClassSwapAndGCClass
	"This test demonstrates that the class object is really being garbageCollected"
	| inst aProxy  methodDictSize compiledMethodsSize |
	3 timesRepeat: [Smalltalk garbageCollect].
	
	methodDictSize := MethodDictionary instanceCount.
	compiledMethodsSize := CompiledMethod instanceCount.

	Transcript show: 'MethodDictionary instanceCount before install ', (MethodDictionary instanceCount) asString; cr.
	Transcript show: 'CompiledMethod instanceCount before install ', (CompiledMethod instanceCount) asString; cr.
	
	inst := ClassWith1Var new.
	aProxy := self installClassProxyOn: ClassWith1Var.
	
	[ 	3 timesRepeat: [Smalltalk garbageCollect].
		
	Transcript show: 'MethodDictionary instanceCount after install ', (MethodDictionary instanceCount) asString; cr.
	Transcript show: 'CompiledMethod instanceCount after install ', (CompiledMethod instanceCount) asString; cr.

	
	self assert: methodDictSize equals: (MethodDictionary instanceCount + 1). 
	self assert: compiledMethodsSize equals: (CompiledMethod instanceCount + ClassWith1Var methodDict size). 
	
	self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	
	Transcript show: 'MethodDictionary instanceCount after uninstall ', (MethodDictionary instanceCount) asString; cr.
	Transcript show: 'CompiledMethod instanceCount after install ', (CompiledMethod instanceCount) asString; cr.

	self assert: methodDictSize equals: MethodDictionary instanceCount. 
	self assert: compiledMethodsSize equals: CompiledMethod instanceCount. 
	
	
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'das 7/4/2011 16:31'!
testClassSwapAndGCMetaclass
	"This test demonstrates that the class object is really being garbageCollected"
	| inst aProxy  metaclassesSize  |
	
	3 timesRepeat: [Smalltalk garbageCollect].

	metaclassesSize := Metaclass instanceCount.

	Transcript show: 'Metaclass instanceCount before install ', (Metaclass instanceCount) asString; cr.
	
	inst := ClassWith1Var new.
	aProxy := self installClassProxyOn: ClassWith1Var.
	
	[ 	3 timesRepeat: [Smalltalk garbageCollect].
		
	Transcript show: 'Metaclass instanceCount after install ', (Metaclass instanceCount) asString; cr.
	
	"The metaclass should have been garbage collected but I don't know why it is not right now. However, once the test execution is finihsed or even when the class is then materialized, the metaclass is garbage collected. So, I cannot do the followin aassert:'
	self assert: metaclassesSize equals: Metaclass instanceCount + 1. "
	
	self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	
	Transcript show: 'Metaclass instanceCount after uninstall ', (Metaclass instanceCount) asString; cr.
	
	"When materializing a new class, the previous metaclass should be garbage collected and hence the amount of metaclasses should be the same as the beginning"
	self assert: metaclassesSize equals: Metaclass instanceCount.
	
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'das 7/4/2011 16:40'!
testClassSwapAndGCMetaclassKeepingReference
	"This test demonstrates that the class object is really being garbageCollected"
	| inst aProxy  metaclassesSize  metaclass |
	
	3 timesRepeat: [Smalltalk garbageCollect].

	metaclassesSize := Metaclass instanceCount.
	metaclass := ClassWith1Var class.
	
	Transcript show: 'Metaclass instanceCount before install ', (Metaclass instanceCount) asString; cr.
	
	inst := ClassWith1Var new.
	aProxy := self installClassProxyOn: ClassWith1Var.
	
	[ 	3 timesRepeat: [Smalltalk garbageCollect].
		
	Transcript show: 'Metaclass instanceCount after install ', (Metaclass instanceCount) asString; cr.
	
	"The metaclass should have been garbage collected but I don't know why it is not right now. However, once the test execution is finihsed or even when the class is then materialized, the metaclass is garbage collected. So, I cannot do the followin aassert:'
	self assert: metaclassesSize equals: Metaclass instanceCount + 1. "
	
	self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
	
	3 timesRepeat: [Smalltalk garbageCollect].
	
	Transcript show: 'Metaclass instanceCount after uninstall ', (Metaclass instanceCount) asString; cr.
	
	"When materializing a new class, the previous metaclass should be garbage collected and hence the amount of metaclasses should be the same as the beginning"
	self assert: metaclassesSize equals: Metaclass instanceCount.
	
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 6/28/2011 16:27'!
testClassSwapRestoreByClass
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	
	| aProxy className |
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self assert: (Smalltalk at: className) fooClass equals: 'fooClass'.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxy.
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: ''!
testClassSwapRestoreByClassAndIsCompact

	| aProxy className |
	className := CompactClassMock name.
	self should: [self installClassProxyOn: CompactClassMock] raise: CannotProxifyCompactClasses  

! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 6/28/2011 16:27'!
testClassSwapRestoreByClassAndNotUnderstood
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message directly to the class"
	
	|  aProxy className |
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self should: [ (Smalltalk at: className) zaraza ] raise: Error.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxy.
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 6/28/2011 16:27'!
testClassSwapRestoreByInstances
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	
	| inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self assert: inst foo equals: 'foo'.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxy.
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: ''!
testClassSwapRestoreByInstancesAndClassIsCompact
	"With this test I want to demonstrate that we have a problem with compact classes. It doesn't work when having compact classes, since their instances, do not have a class pointer, and hence, the #become: doesn't update those pointers to point to my proxy. So....nothing to do."

	| inst aProxy className |
	inst := ClassWith1Var new.
	className := CompactClassMock name.
	self should: [self installClassProxyOn: CompactClassMock] raise: CannotProxifyCompactClasses.
	! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 6/28/2011 16:27'!
testClassSwapRestoreByInstancesAndNotUnderstood
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	
	| inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert: (Smalltalk at: className) ==  ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	self should: [inst zaraza] raise: Error.
	"Now lets check that the proxy was uninstalled"
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxy.
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].
! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 6/28/2011 16:50'!
testClassSwapRestoreByInstancesAndUnderstoodByBoth
	"This is a more complex test with several asserts. The important thing in this test is that the original class is restored while sending a message to an instance of it."
	
	|  inst aProxy className |
	inst := ClassWith1Var new.
	className := ClassWith1Var name.
	aProxy := self installClassProxyOn: ClassWith1Var.
	"after this is done, aProxy is pointing to ClassWith1Var"
	[self assert:  (Smalltalk at: className) == ClassWith1Var.
	self assert: (Smalltalk at: className) mareaClass name equals: proxyClassName.
	self assert: (Smalltalk at: className) mareaIsProxyInstalled.
	"We are sure that the proxy was installed, now, lets uninstall it sending any message to the class"
	 inst basicIdentityHash.
	 inst == Object new.
	"Notice that #basicIdentityHash  #==  ARE understood by both, the original object and the proxy, but in this case, the proxy IS uninstalled. Why?  because in this case, the uninstall happens because of the #cannotInterpret instead of the #doesNotUnderstand.  When using #cannotInterpret, we handle ANY message, not only the ones not understood. "
	self assert: (Smalltalk at: className) mareaClass name equals: 'ClassWith1Var class'.
	self assert: (Smalltalk at: className) name equals: 'ClassWith1Var'.
	self deny: aProxy mareaIsProxy.
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].

! !

!ClassProxySwapperTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 6/27/2011 16:54'!
testClassSwapSimple

	| inst aProxy |
	inst := ClassWith1Var new.
	aProxy := self installClassProxyOn: ClassWith1Var.
	[ self assert: (inst class == ClassWith1Var).
	self assert: inst foo = 'foo'.
	] ensure: [ aProxy mareaIsProxy ifTrue:  [ aProxy mareaUninstallIfNeeded]].


! !

TestCase subclass: #MetaclassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!MetaclassTest methodsFor: 'as yet unclassified' stamp: ''!
testMetaclassGC
"	Transcript show: 'metaclases antes: ', Metaclass instanceCount  asString; cr.
	Smalltalk garbageCollect.
	ClassWith1Var become: ClassWith2Var new.
	Smalltalk garbageCollect.
	Transcript show: 'metaclases antes: ', Metaclass instanceCount  asString; cr.
	
	"! !

TestCase subclass: #ObjectProxySwapperTest
	instanceVariableNames: 'proxyClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProxiesTests'!

!ObjectProxySwapperTest methodsFor: 'tests' stamp: ''!
installProxyOn: anObject. 
	^ self proxyClass installOn: anObject.! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: ''!
proxyClass
	^ proxyClass! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: 'MarianoMartinezPeck 7/1/2011 15:42'!
setUp
	ObjectProxySwapperHandler serializer: FuelMareaSerializer. 
	proxyClass := NumberAsFilenameObjectProxySwapper.
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	self proxyClass runningTest: true.
	! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: ''!
tearDown
"	(FileDirectory default fileNamesMatching: '*.swap') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: ''!
testClassSelector
	| anObject |
	
	anObject := DateAndTime new.
	
	self installProxyOn: anObject. 
	
	[self assert: anObject mareaClass equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.
	anObject class.
	anObject mareaClass.
	"all methos that start with marea are understood"
	self assert: anObject mareaIsProxyInstalled.
	
	self proxyClass runningTest: false.
	"since we are not running tests, #class should uninstall the proxy"
	anObject class.
	
	self assert: anObject class equals: DateAndTime.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: ''!
testIdentity
	| anObject anotherPointer |
	
	anObject := DateAndTime new.
	anotherPointer := anObject.
	
	self installProxyOn: anObject. 
	
	[self assert: anObject mareaClass equals: self proxyClass..
	self assert: anObject mareaIsProxyInstalled.
	anObject mareaUninstallIfNeeded.
	self assert: anotherPointer == anObject.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: ''!
testOneSingleObject
	| anObject |
	
	anObject := DateAndTime new.
	
	self installProxyOn: anObject. 
	
	[self assert: anObject mareaClass equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.
	anObject name.
	self assert: anObject class equals: DateAndTime.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].

! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: ''!
testOneSingleObjectProxyDNU

	| anObject |
	
	anObject := ClassWith1Var new.
	self installProxyOn: anObject. 
	[self assert: anObject class equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.

	self should: [anObject zaraza] raise: MessageNotUnderstood.
	
	self assert: anObject class equals: ClassWith1Var.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].
! !

!ObjectProxySwapperTest methodsFor: 'tests' stamp: ''!
testOneSingleObjectProxyUndetstandsDNU
	"The object that we swap does also understand the message doesNotUnderstand. We have to be sure not to loop and to correctly call both doesNotUnderstand:"
	| anObject |
	
	anObject := ClassWithDNU new.
	self installProxyOn: anObject. 
	[self assert: anObject class equals: self proxyClass.
	self assert: anObject mareaIsProxyInstalled.
	self assert: anObject zaraza equals: 'dnu'.
	self assert: anObject class equals: ClassWithDNU.

	] ensure: [ anObject mareaIsProxy ifTrue:  [ anObject mareaUninstallIfNeeded]].
! !

!ReferenceStreamMareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:29'!
internalMethodForTesting
	^ ReferenceStream methodDict at: #next.! !

!TestSuite methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/30/2010 18:07'!
tests: aCollectionOfTests
	tests := aCollectionOfTests 
			! !

!FuelMareaSerializer methodsFor: '*ProxiesTests' stamp: 'MarianoMartinezPeck 11/24/2010 23:38'!
internalMethodForTesting
	^ FLMaterializer methodDict at: #materialize! !
